package com.bizmatics.controller.web;


import com.bizmatics.common.core.bean.ApiResult;
import com.bizmatics.common.core.bean.CommonPage;
import com.bizmatics.model.vo.SysOperLogVo;
import com.bizmatics.service.system.ISysOperLogService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * 统计管理-用户操作日志
 *
 * @author ya
 * @since 2022-06-02
 */
@RestController
@RequestMapping("/sysOperLog")
public class SysOperLogController {

    @Autowired
    private ISysOperLogService sysOperLogService;

    /**
     * 统计管理-用户操作日志-列表查询
     *
     * @param title        系统模块
     * @param operName     操作账号
     * @param businessType 操作类别 （0其它 1新增 2修改 3删除）
     * @param status       操作状态（0正常 1异常）
     * @param startTime    开始时间 2021-01-01 15:15:15
     * @param endTime      结束时间 2021-01-01 15:15:15
     * @param page         当前页
     * @param size         条数
     * @param operId           记录id 详情使用
     * @return
     */
    @GetMapping("/getOperLogList")
    public ApiResult<CommonPage<SysOperLogVo>> getOperLogList(@RequestParam(value = "title", required = false) String title,
                                                              @RequestParam(value = "operName", required = false) String operName,
                                                              @RequestParam(value = "businessType", required = false) Integer businessType,
                                                              @RequestParam(value = "status", required = false, defaultValue = "2") Integer status,
                                                              @RequestParam(value = "startTime", required = false) String startTime,
                                                              @RequestParam(value = "endTime", required = false) String endTime,
                                                              @RequestParam(value = "page", required = false, defaultValue = "1") Integer page,
                                                              @RequestParam(value = "size", required = false, defaultValue = "10") Integer size,
                                                              @RequestParam(value = "operId", required = false, defaultValue = "0") Integer operId) {
        return ApiResult.success(sysOperLogService.getOperLogList(title, operName, status, businessType, operId, startTime, endTime, page, size));
    }

}

