package com.bizmatics.controller.web;


import com.bizmatics.common.core.bean.ApiResult;
import com.bizmatics.common.core.exception.BusinessErrorCode;
import com.bizmatics.common.mvc.utils.ServletUtils;
import com.bizmatics.model.constants.UserConstants;
import com.bizmatics.model.system.SysMenu;
import com.bizmatics.model.system.SysRole;
import com.bizmatics.service.UserSiteService;
import com.bizmatics.service.config.security.LoginUser;
import com.bizmatics.service.system.ISysMenuService;
import com.bizmatics.service.system.ISysRoleService;
import com.bizmatics.service.system.ISysUserService;
import com.bizmatics.service.system.impl.SysPermissionService;
import com.bizmatics.service.system.impl.TokenService;
import com.bizmatics.service.util.SecurityUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Objects;

/**
 * 用户站点信息
 *
 * @author ya
 * @since 2021-07-07
 */
@RestController
@RequestMapping("/userSite")
public class UserSiteController {

    @Autowired
    private UserSiteService userSiteService;
    @Autowired
    private ISysMenuService menuService;
    /**
     * 根据菜单查询按钮
     *
     * @param menuName 菜单名称
     * @return
     */
    @GetMapping(value = "/getButtonlistone")
    public ApiResult<List<SysMenu>> getButtonlistone(@RequestParam(value = "menuName", required = false) String menuName) {
        return ApiResult.success(menuService.getButtonlist(menuName));
    }

//    @GetMapping(value = "/getAuthority")
//    public ApiResult<List<Object>> getAuthority(@RequestParam(value = "roleId") Long roleId) {
//        return ApiResult.success(menuService.getAuthority(roleId));
//    }

    @GetMapping(value = "/getAuthority")
    public ApiResult<List<Object>> getAuthority(@RequestParam(value = "roleId") Long roleId) {
        return ApiResult.success(menuService.getAuthority1(roleId));
    }
}

