package com.bizmatics.model;

import com.baomidou.mybatisplus.annotation.IdType;
import java.time.LocalDate;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 
 * </p>
 *
 * @author ya
 * @since 2022-03-15
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class HtAnalog171Data implements Serializable {

    private static final long serialVersionUID=1L;

    /**
     * 伍继电力hz171消费组模拟量历史数据表ID
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 阿里云平台设备名称
     */
    @TableField("deviceName")
    private String deviceName;

    /**
     * A相电压
     */
    @TableField("voltageA")
    private Double voltageA;

    /**
     * B相电压
     */
    @TableField("voltageB")
    private Double voltageB;

    /**
     * C相电压
     */
    @TableField("voltageC")
    private Double voltageC;

    /**
     * AB线电压
     */
    @TableField("voltageAB")
    private Double voltageAB;

    /**
     * BC线电压
     */
    @TableField("voltageBC")
    private Double voltageBC;

    /**
     * CA线电压
     */
    @TableField("voltageCA")
    private Double voltageCA;

    /**
     * 频率
     */
    private Double frequency;

    /**
     * 直流遥测1
     */
    private Double analog1;

    /**
     * 直流遥测2
     */
    private Double analog2;

    /**
     * 直流遥测3
     */
    private Double analog3;

    /**
     * 直流遥测4
     */
    private Double analog4;

    /**
     * 直流遥测5
     */
    private Double analog5;

    /**
     * A相电压THD
     */
    @TableField("voltageATHD")
    private Double voltageATHD;

    /**
     * B相电压THD
     */
    @TableField("voltageBTHD")
    private Double voltageBTHD;

    /**
     * C相电压THD
     */
    @TableField("voltageCTHD")
    private Double voltageCTHD;

    /**
     * 电压暂降次数
     */
    @TableField("voltageSagTimes")
    private Integer voltageSagTimes;

    /**
     * 电压暂升次数
     */
    @TableField("voltageSwellTimes")
    private Integer voltageSwellTimes;

    /**
     * 电压中断次数
     */
    @TableField("voltageInterruptionTimes")
    private Integer voltageInterruptionTimes;

    /**
     * 电压不平衡度
     */
    @TableField("voltageUnbalanceFactor")
    private Double voltageUnbalanceFactor;

    /**
     * 遥测备用
     */
    @TableField("analogReserved")
    private Double analogReserved;

    /**
     * 冻结时间
     */
    @TableField("freezingTime")
    private LocalDate freezingTime;

    /**
     * 上报时间
     */
    @TableField("dataTime")
    private LocalDateTime dataTime;


}
