package com.bizmatics.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 
 * </p>
 *
 * @author ya
 * @since 2022-03-15
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class RtSwitch171Data implements Serializable {

    private static final long serialVersionUID=1L;

    /**
     * 伍继电力hz171消费组开关量实时数据表ID
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 阿里云平台设备名称
     */
    @TableField("deviceName")
    private String deviceName;

    /**
     * 通讯状态(0 通讯中断  1 正常通讯)
     */
    @TableField("commState")
    private Integer commState;

    /**
     * 母线带电(0 正常  1 告警)
     */
    @TableField("busLive")
    private Integer busLive;

    /**
     * 电压越上限(0 正常  1 告警)
     */
    @TableField("highVoltageAlarm")
    private Integer highVoltageAlarm;

    /**
     * 电压越下限(0 正常  1 告警)
     */
    @TableField("lowVoltageAlarm")
    private Integer lowVoltageAlarm;

    /**
     * 缺相(0 正常  1 告警)
     */
    @TableField("busLackPhase")
    private Integer busLackPhase;

    /**
     * 直流量告警1(0 正常  1 告警)
     */
    @TableField("analog1Alarm")
    private Integer analog1Alarm;

    /**
     * 直流量告警2(0 正常  1 告警)
     */
    @TableField("analog2Alarm")
    private Integer analog2Alarm;

    /**
     * 直流量告警3(0 正常  1 告警)
     */
    @TableField("analog3Alarm")
    private Integer analog3Alarm;

    /**
     * 直流量告警4(0 正常  1 告警)
     */
    @TableField("analog4Alarm")
    private Integer analog4Alarm;

    /**
     * 直流量告警5(0 正常  1 告警)
     */
    @TableField("analog5Alarm")
    private Integer analog5Alarm;

    /**
     * 预留1(0 正常  1 告警)
     */
    @TableField("digitalReserved1")
    private Integer digitalReserved1;

    /**
     * 预留2(0 正常  1 告警)
     */
    @TableField("digitalReserved2")
    private Integer digitalReserved2;

    /**
     * 预留3(0 正常  1 告警)
     */
    @TableField("digitalReserved3")
    private Integer digitalReserved3;

    /**
     * 预留4(0 正常  1 告警)
     */
    @TableField("digitalReserved4")
    private Integer digitalReserved4;

    /**
     * 预留5(0 正常  1 告警)
     */
    @TableField("digitalReserved5")
    private Integer digitalReserved5;

    /**
     * 预留6(0 正常  1 告警)
     */
    @TableField("digitalReserved6")
    private Integer digitalReserved6;

    /**
     * 上报时间
     */
    @TableField("dataTime")
    private LocalDateTime dataTime;


}
