package com.bizmatics.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 
 * </p>
 *
 * @author ya
 * @since 2022-03-15
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class RtSwitch173Data implements Serializable {

    private static final long serialVersionUID=1L;

    /**
     * 伍继电力hz173消费组开关量实时数据表ID
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 阿里云平台设备名称
     */
    @TableField("deviceName")
    private String deviceName;

    /**
     * 通讯状态(0 通讯中断  1 正常通讯)
     */
    @TableField("commState")
    private Integer commState;

    /**
     * 回路带电(0 正常  1 告警)
     */
    @TableField("LoadLive")
    private Integer LoadLive;

    /**
     * 回路跳闸(0 正常  1 告警)
     */
    @TableField("Trip")
    private Integer Trip;

    /**
     * 电流越限(0 正常  1 告警)
     */
    @TableField("OverI")
    private Integer OverI;

    /**
     * 电压缺相(0 正常  1 告警)
     */
    @TableField("PhaseLoss")
    private Integer PhaseLoss;

    /**
     * 低压(0 正常  1 告警)
     */
    @TableField("UnderV")
    private Integer UnderV;

    /**
     * 需量超限(0 正常  1 告警)
     */
    @TableField("OverDemandP")
    private Integer OverDemandP;

    /**
     * 剩余电流超限(0 正常  1 告警)
     */
    @TableField("OverIr")
    private Integer OverIr;

    /**
     * T1超温(0 正常  1 告警)
     */
    @TableField("OverT1")
    private Integer OverT1;

    /**
     * T2超温(0 正常  1 告警)
     */
    @TableField("OverT2")
    private Integer OverT2;

    /**
     * T3超温(0 正常  1 告警)
     */
    @TableField("OverT3")
    private Integer OverT3;

    /**
     * 通用遥信1(0 正常  1 告警)
     */
    @TableField("DI1")
    private Integer di1;

    /**
     * 通用遥信2(0 正常  1 告警)
     */
    @TableField("DI2")
    private Integer di2;

    /**
     * 继电器1状态(0 正常  1 告警)
     */
    @TableField("DO1")
    private Integer do1;

    /**
     * 继电器2状态(0 正常  1 告警)
     */
    @TableField("DO2")
    private Integer do2;

    /**
     * 备用遥信1(0 正常  1 告警)
     */
    @TableField("ResDI1")
    private Integer ResDI1;

    /**
     * 备用遥信2(0 正常  1 告警)
     */
    @TableField("ResDI2")
    private Integer ResDI2;

    /**
     * 备用遥信3(0 正常  1 告警)
     */
    @TableField("ResDI3")
    private Integer ResDI3;

    /**
     * 上报时间
     */
    @TableField("dataTime")
    private LocalDateTime dataTime;


}
