package com.bizmatics.model.vo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 
 * </p>
 *
 * @author ya
 * @since 2022-03-07
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class HookupComponentCompleteOneVo implements Serializable {

    private static final long serialVersionUID=1L;

    /**
     * 接线图元器件详细数据关联表ID
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 类别
     */
    private Integer sort;

    /**
     * 标题
     */
    private String title;

    /**
     * 内部类型
     */
    private String type;

    /**
     * 类型名称
     */
    @TableField("typeName")
    private String typeName;

    /**
     * 元器件颜色
     */
    @TableField("svgColor")
    private String svgColor;

    /**
     * 元器件X坐标
     */
    @TableField("svgPositionX")
    private Integer svgPositionX;

    /**
     * 元器件Y坐标
     */
    @TableField("svgPositionY")
    private Integer svgPositionY;

    /**
     * 大小
     */
    private Integer size;

    /**
     * 高度
     */
    private Integer height;

    /**
     * 宽度
     */
    private Integer width;

    /**
     * 字体大小
     */
    @TableField("fontSize")
    private Integer fontSize;

    /**
     * 元器件描述
     */
    @TableField("svgText")
    private String svgText;

    /**
     * 角度
     */
    private Integer angle;

    /**
     * 表行数
     */
    @TableField("tableRowCount")
    private Integer tableRowCount;

    /**
     * 表列数
     */
    @TableField("tableColCount")
    private Integer tableColCount;

    /**
     * 表数据
     */
    @TableField("tableData")
    private Object tableData;

    @TableField("elementBool")
    private Object elementBool;

    /**
     * 所属站点ID
     */
    private Integer siteId;

    /**
     * 所属设备ID
     */
    private Integer deviceId;

    /**
     * 所属变量ID
     */
    private Integer variableId;

    /**
     * 创建人
     */
    private String creator;

    /**
     * 创建时间
     */
    private LocalDateTime createTime;


    private String createType;
    @TableField("mPoint")
    @JsonProperty("mPoint")
    private String mPoint;
    private String echartsOption;
    private String svgLineSelectval;


}
