package com.bizmatics.model.vo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Date;

/**
 * <p>
 * 
 * </p>
 *
 * @author ya
 * @since 2021-07-07
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class RtAnalogDataOneVo implements Serializable {

    private static final long serialVersionUID=1L;

    /**
     * 伍继电力test_183消费组模拟量数据表ID
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 阿里云平台设备名称
     */
    @TableField("deviceName")
    private String deviceName;

    /**
     * 母线停电次数
     */
    @TableField("Busot")
    private Integer Busot;

    /**
     * 三相功率因数
     */
    @TableField("COS")
    private Double cos;

    /**
     * A相功率因数
     */
    @TableField("COSa")
    private Double COSa;

    /**
     * B相功率因数
     */
    @TableField("COSb")
    private Double COSb;

    /**
     * C相功率因数
     */
    @TableField("COSc")
    private Double COSc;

    /**
     * 实时有功需量
     */
    @TableField("Demand")
    private Double Demand;

    /**
     * 设备复位次数
     */
    @TableField("DevResetTimes")
    private Integer DevResetTimes;

    /**
     * 设备温度
     */
    @TableField("DeviceTemp")
    private Double DeviceTemp;

    /**
     * 三相反向有功电度
     */
    @TableField("Epn")
    private Double Epn;

    /**
     * 尖段反向有功电度
     */
    @TableField("Epn1")
    private Double Epn1;

    /**
     * 峰段反向有功电度
     */
    @TableField("Epn2")
    private Double Epn2;

    /**
     * 平段反向有功电度
     */
    @TableField("Epn3")
    private Double Epn3;

    /**
     * 谷段反向有功电度
     */
    @TableField("Epn4")
    private Double Epn4;

    /**
     * 三相正向有功电度
     */
    @TableField("Epp")
    private Double Epp;

    /**
     * 尖段正向有功电度
     */
    @TableField("Epp1")
    private Double Epp1;

    /**
     * 峰段正向有功电度
     */
    @TableField("Epp2")
    private Double Epp2;

    /**
     * 平段正向有功电度
     */
    @TableField("Epp3")
    private Double Epp3;

    /**
     * 谷段正向有功电度
     */
    @TableField("Epp4")
    private Double Epp4;

    /**
     * 三相反向无功电度
     */
    @TableField("Eqn")
    private Double Eqn;

    /**
     * 三相正向无功电度
     */
    @TableField("Eqp")
    private Double Eqp;

    /**
     * 频率
     */
    @TableField("F")
    private Double f;

    /**
     * 零序电流
     */
    @TableField("I0")
    private Double i0;

    /**
     * 负序电流
     */
    @TableField("I2")
    private Double i2;

    /**
     * A相总谐波电流
     */
    @TableField("IHa")
    private Double IHa;

    /**
     * B相总谐波电流
     */
    @TableField("IHb")
    private Double IHb;

    /**
     * C相总谐波电流
     */
    @TableField("IHc")
    private Double IHc;

    /**
     * A相电流
     */
    @TableField("Ia")
    private Double Ia;

    /**
     * B相电流
     */
    @TableField("Ib")
    private Double Ib;

    /**
     * C相电流
     */
    @TableField("Ic")
    private Double Ic;

    /**
     * 剩余电流
     */
    @TableField("Ir")
    private Double Ir;

    /**
     * 昨日有功最大需量
     */
    @TableField("LastDayMD")
    private Double LastDayMD;

    /**
     * 昨日有功最大需量发生时间
     */
    @TableField("LastDayMDt")
    private Double LastDayMDt;

    /**
     * 三相总有功功率
     */
    @TableField("P")
    private Double p;

    /**
     * A相有功功率
     */
    @TableField("Pa")
    private Double Pa;

    /**
     * B相有功功率
     */
    @TableField("Pb")
    private Double Pb;

    /**
     * C相有功功率
     */
    @TableField("Pc")
    private Double Pc;

    /**
     * 三相总无功功率
     */
    @TableField("Q")
    private Double q;

    /**
     * A相无功功率
     */
    @TableField("Qa")
    private Double Qa;

    /**
     * B相无功功率
     */
    @TableField("Qb")
    private Double Qb;

    /**
     * C相无功功率
     */
    @TableField("Qc")
    private Double Qc;

    /**
     * 信号强度
     */
    @TableField("SignalIntensity")
    private Double SignalIntensity;

    /**
     * 第1路温度
     */
    @TableField("T1")
    private Double t1;

    /**
     * 第2路温度
     */
    @TableField("T2")
    private Double t2;

    /**
     * 第3路温度
     */
    @TableField("T3")
    private Double t3;

    /**
     * 第4路温度
     */
    @TableField("T4")
    private Double t4;

    /**
     * A相电压THD
     */
    @TableField("THDUa")
    private Double THDUa;

    /**
     * B相电压THD
     */
    @TableField("THDUb")
    private Double THDUb;

    /**
     * C相电压THD
     */
    @TableField("THDUc")
    private Double THDUc;

    /**
     * A相电压
     */
    @TableField("Ua")
    private Double Ua;

    /**
     * AB线电压
     */
    @TableField("Uab")
    private Double Uab;

    /**
     * B相电压
     */
    @TableField("Ub")
    private Double Ub;

    /**
     * BC线电压
     */
    @TableField("Ubc")
    private Double Ubc;

    /**
     * 零序电压不平衡度
     */
    @TableField("UblU0")
    private Double UblU0;

    /**
     * 负序电压不平衡度
     */
    @TableField("UblU2")
    private Double UblU2;

    /**
     * C相电压
     */
    @TableField("Uc")
    private Double Uc;

    /**
     * CA线电压
     */
    @TableField("Uca")
    private Double Uca;

    /**
     * 电压暂降次数
     */
    @TableField("Udt")
    private Integer Udt;

    /**
     * 线路侧电压
     */
    @TableField("Ul")
    private Double Ul;

    /**
     * 电压暂升次数
     */
    @TableField("Upt")
    private Integer Upt;

    /**
     * 电压短时中断次数
     */
    @TableField("Ust")
    private Integer Ust;

    /**
     * 冻结时间
     */
    @TableField("freezingTime")
    private Date freezingTime;

    /**
     * 上报时间
     */
    @TableField("dataTime")
    private Date dataTime;

    /**
     * 变量名称
     */
    @TableField("variable_coding")
    private String variableCoding;

    /**
     * A相电压
     */
    @TableField("voltageA")
    private Double voltageA;

    /**
     * B相电压
     */
    @TableField("voltageB")
    private Double voltageB;

    /**
     * C相电压
     */
    @TableField("voltageC")
    private Double voltageC;

    /**
     * AB线电压
     */
    @TableField("voltageAB")
    private Double voltageAB;

    /**
     * BC线电压
     */
    @TableField("voltageBC")
    private Double voltageBC;

    /**
     * CA线电压
     */
    @TableField("voltageCA")
    private Double voltageCA;

    /**
     * 频率
     */
    private Double frequency;

    /**
     * 直流遥测1
     */
    private Double analog1;

    /**
     * 直流遥测2
     */
    private Double analog2;

    /**
     * 直流遥测3
     */
    private Double analog3;

    /**
     * 直流遥测4
     */
    private Double analog4;

    /**
     * 直流遥测5
     */
    private Double analog5;

    /**
     * A相电压THD
     */
    @TableField("voltageATHD")
    private Double voltageATHD;

    /**
     * B相电压THD
     */
    @TableField("voltageBTHD")
    private Double voltageBTHD;

    /**
     * C相电压THD
     */
    @TableField("voltageCTHD")
    private Double voltageCTHD;

    /**
     * 电压暂降次数
     */
    @TableField("voltageSagTimes")
    private Integer voltageSagTimes;

    /**
     * 电压暂升次数
     */
    @TableField("voltageSwellTimes")
    private Integer voltageSwellTimes;

    /**
     * 电压中断次数
     */
    @TableField("voltageInterruptionTimes")
    private Integer voltageInterruptionTimes;

    /**
     * 电压不平衡度
     */
    @TableField("voltageUnbalanceFactor")
    private Double voltageUnbalanceFactor;

    /**
     * 遥测备用
     */
    @TableField("analogReserved")
    private Double analogReserved;

    /**
     * 不平衡电流
     */
    @TableField("unbalanceCurrent")
    private Double unbalanceCurrent;

    /**
     * 不平衡电压
     */
    @TableField("unbalanceVoltage")
    private Double unbalanceVoltage;

    /**
     * 遥测备用1
     */
    @TableField("analogReserved1")
    private Double analogReserved1;

    /**
     * 遥测备用2
     */
    @TableField("analogReserved2")
    private Double analogReserved2;

    /**
     * 遥测备用3
     */
    @TableField("analogReserved3")
    private Double analogReserved3;

    /**
     * 遥测备用4
     */
    @TableField("analogReserved4")
    private Double analogReserved4;


    /**
     * 通讯状态(0 通讯中断  1 正常通讯)
     */
    @TableField("commState")
    private Integer commState;

    /**
     * 母线带电(0 正常  1 告警)
     */
    @TableField("busLive")
    private Integer busLive;

    /**
     * 电压越上限(0 正常  1 告警)
     */
    @TableField("highVoltageAlarm")
    private Integer highVoltageAlarm;

    /**
     * 电压越下限(0 正常  1 告警)
     */
    @TableField("lowVoltageAlarm")
    private Integer lowVoltageAlarm;

    /**
     * 缺相(0 正常  1 告警)
     */
    @TableField("busLackPhase")
    private Integer busLackPhase;

    /**
     * 直流量告警1(0 正常  1 告警)
     */
    @TableField("analog1Alarm")
    private Integer analog1Alarm;

    /**
     * 直流量告警2(0 正常  1 告警)
     */
    @TableField("analog2Alarm")
    private Integer analog2Alarm;

    /**
     * 直流量告警3(0 正常  1 告警)
     */
    @TableField("analog3Alarm")
    private Integer analog3Alarm;

    /**
     * 直流量告警4(0 正常  1 告警)
     */
    @TableField("analog4Alarm")
    private Integer analog4Alarm;

    /**
     * 直流量告警5(0 正常  1 告警)
     */
    @TableField("analog5Alarm")
    private Integer analog5Alarm;

    /**
     * 预留1(0 正常  1 告警)
     */
    @TableField("digitalReserved1")
    private Integer digitalReserved1;

    /**
     * 预留2(0 正常  1 告警)
     */
    @TableField("digitalReserved2")
    private Integer digitalReserved2;

    /**
     * 预留3(0 正常  1 告警)
     */
    @TableField("digitalReserved3")
    private Integer digitalReserved3;

    /**
     * 预留4(0 正常  1 告警)
     */
    @TableField("digitalReserved4")
    private Integer digitalReserved4;

    /**
     * 预留5(0 正常  1 告警)
     */
    @TableField("digitalReserved5")
    private Integer digitalReserved5;

    /**
     * 预留6(0 正常  1 告警)
     */
    @TableField("digitalReserved6")
    private Integer digitalReserved6;


    /**
     * 回路带电(0 正常  1 告警)
     */
    @TableField("LoadLive")
    private Integer LoadLive;

    /**
     * 回路跳闸(0 正常  1 告警)
     */
    @TableField("Trip")
    private Integer Trip;

    /**
     * 电流越限(0 正常  1 告警)
     */
    @TableField("OverI")
    private Integer OverI;

    /**
     * 电压缺相(0 正常  1 告警)
     */
    @TableField("PhaseLoss")
    private Integer PhaseLoss;

    /**
     * 低压(0 正常  1 告警)
     */
    @TableField("UnderV")
    private Integer UnderV;

    /**
     * 需量超限(0 正常  1 告警)
     */
    @TableField("OverDemandP")
    private Integer OverDemandP;

    /**
     * 剩余电流超限(0 正常  1 告警)
     */
    @TableField("OverIr")
    private Integer OverIr;

    /**
     * T1超温(0 正常  1 告警)
     */
    @TableField("OverT1")
    private Integer OverT1;

    /**
     * T2超温(0 正常  1 告警)
     */
    @TableField("OverT2")
    private Integer OverT2;

    /**
     * T3超温(0 正常  1 告警)
     */
    @TableField("OverT3")
    private Integer OverT3;

    /**
     * 通用遥信1(0 正常  1 告警)
     */
    @TableField("DI1")
    private Integer di1;

    /**
     * 通用遥信2(0 正常  1 告警)
     */
    @TableField("DI2")
    private Integer di2;

    /**
     * 继电器1状态(0 正常  1 告警)
     */
    @TableField("DO1")
    private Integer do1;

    /**
     * 继电器2状态(0 正常  1 告警)
     */
    @TableField("DO2")
    private Integer do2;

    /**
     * 备用遥信1(0 正常  1 告警)
     */
    @TableField("ResDI1")
    private Integer ResDI1;

    /**
     * 备用遥信2(0 正常  1 告警)
     */
    @TableField("ResDI2")
    private Integer ResDI2;

    /**
     * 备用遥信3(0 正常  1 告警)
     */
    @TableField("ResDI3")
    private Integer ResDI3;

    /**
     * A相燃弧(0 正常  1 告警)
     */
    @TableField("ArcA")
    private Integer ArcA;

    /**
     * B相燃弧(0 正常  1 告警)
     */
    @TableField("ArcB")
    private Integer ArcB;

    /**
     * C相燃弧(0 正常  1 告警)
     */
    @TableField("ArcC")
    private Integer ArcC;

    /**
     * 母线停电(0 正常  1 告警)
     */
    @TableField("BusOutage")
    private Integer BusOutage;

    /**
     * 开入3(0 正常  1 告警)
     */
    @TableField("DI3")
    private Integer di3;

    /**
     * 设备异常(0 正常  1 告警)
     */
    @TableField("DevAbnormal")
    private Integer DevAbnormal;

    /**
     * 线路电气故障总(0 正常  1 告警)
     */
    @TableField("EleAlarm")
    private Integer EleAlarm;

    /**
     * 火灾预警总(0 正常  1 告警)
     */
    @TableField("FireAlarm")
    private Integer FireAlarm;

    /**
     * 线路开关状态(0 正常  1 告警)
     */
    @TableField("LoadBrkState")
    private Integer LoadBrkState;

    /**
     * 测量通道故障(0 正常  1 告警)
     */
    @TableField("MeasFailure")
    private Integer MeasFailure;

    /**
     * 消音(0 正常  1 告警)
     */
    @TableField("Mute")
    private Integer Mute;

    /**
     * 视在需量超限(0 正常  1 告警)
     */
    @TableField("OverDemandS")
    private Integer OverDemandS;

    /**
     * 环境温度越限(0 正常  1 告警)
     */
    @TableField("OverEvT")
    private Integer OverEvT;

    /**
     * 电流谐波越限(0 正常  1 告警)
     */
    @TableField("OverIH")
    private Integer OverIH;

    /**
     * 测温点4超温(0 正常  1 告警)
     */
    @TableField("OverT4")
    private Integer OverT4;

    /**
     * 电压谐波越限(0 正常  1 告警)
     */
    @TableField("OverUH")
    private Integer OverUH;

    /**
     * 过压(0 正常  1 告警)
     */
    @TableField("OverV")
    private Integer OverV;

    /**
     * 备用遥信4(0 正常  1 告警)
     */
    @TableField("ResDI4")
    private Integer ResDI4;

}
