package com.bizmatics.model.vo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 
 * </p>
 *
 * @author ya
 * @since 2022-03-15
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class RtSwitchDataVo implements Serializable {

    private static final long serialVersionUID=1L;

    /**
     * 伍继电力hz171消费组开关量实时数据表ID
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 阿里云平台设备名称
     */
    @TableField("deviceName")
    private String deviceName;

    /**
     * 通讯状态(0 通讯中断  1 正常通讯)
     */
    @TableField("commState")
    private Integer commState;

    /**
     * 母线带电(0 正常  1 告警)
     */
    @TableField("busLive")
    private Integer busLive;

    /**
     * 电压越上限(0 正常  1 告警)
     */
    @TableField("highVoltageAlarm")
    private Integer highVoltageAlarm;

    /**
     * 电压越下限(0 正常  1 告警)
     */
    @TableField("lowVoltageAlarm")
    private Integer lowVoltageAlarm;

    /**
     * 缺相(0 正常  1 告警)
     */
    @TableField("busLackPhase")
    private Integer busLackPhase;

    /**
     * 直流量告警1(0 正常  1 告警)
     */
    @TableField("analog1Alarm")
    private Integer analog1Alarm;

    /**
     * 直流量告警2(0 正常  1 告警)
     */
    @TableField("analog2Alarm")
    private Integer analog2Alarm;

    /**
     * 直流量告警3(0 正常  1 告警)
     */
    @TableField("analog3Alarm")
    private Integer analog3Alarm;

    /**
     * 直流量告警4(0 正常  1 告警)
     */
    @TableField("analog4Alarm")
    private Integer analog4Alarm;

    /**
     * 直流量告警5(0 正常  1 告警)
     */
    @TableField("analog5Alarm")
    private Integer analog5Alarm;

    /**
     * 预留1(0 正常  1 告警)
     */
    @TableField("digitalReserved1")
    private Integer digitalReserved1;

    /**
     * 预留2(0 正常  1 告警)
     */
    @TableField("digitalReserved2")
    private Integer digitalReserved2;

    /**
     * 预留3(0 正常  1 告警)
     */
    @TableField("digitalReserved3")
    private Integer digitalReserved3;

    /**
     * 预留4(0 正常  1 告警)
     */
    @TableField("digitalReserved4")
    private Integer digitalReserved4;

    /**
     * 预留5(0 正常  1 告警)
     */
    @TableField("digitalReserved5")
    private Integer digitalReserved5;

    /**
     * 预留6(0 正常  1 告警)
     */
    @TableField("digitalReserved6")
    private Integer digitalReserved6;

    /**
     * 上报时间
     */
    @TableField("dataTime")
    private LocalDateTime dataTime;

    /**
     * 回路带电(0 正常  1 告警)
     */
    @TableField("LoadLive")
    private Integer LoadLive;

    /**
     * 回路跳闸(0 正常  1 告警)
     */
    @TableField("Trip")
    private Integer Trip;

    /**
     * 电流越限(0 正常  1 告警)
     */
    @TableField("OverI")
    private Integer OverI;

    /**
     * 电压缺相(0 正常  1 告警)
     */
    @TableField("PhaseLoss")
    private Integer PhaseLoss;

    /**
     * 低压(0 正常  1 告警)
     */
    @TableField("UnderV")
    private Integer UnderV;

    /**
     * 需量超限(0 正常  1 告警)
     */
    @TableField("OverDemandP")
    private Integer OverDemandP;

    /**
     * 剩余电流超限(0 正常  1 告警)
     */
    @TableField("OverIr")
    private Integer OverIr;

    /**
     * T1超温(0 正常  1 告警)
     */
    @TableField("OverT1")
    private Integer OverT1;

    /**
     * T2超温(0 正常  1 告警)
     */
    @TableField("OverT2")
    private Integer OverT2;

    /**
     * T3超温(0 正常  1 告警)
     */
    @TableField("OverT3")
    private Integer OverT3;

    /**
     * 通用遥信1(0 正常  1 告警)
     */
    @TableField("DI1")
    private Integer di1;

    /**
     * 通用遥信2(0 正常  1 告警)
     */
    @TableField("DI2")
    private Integer di2;

    /**
     * 继电器1状态(0 正常  1 告警)
     */
    @TableField("DO1")
    private Integer do1;

    /**
     * 继电器2状态(0 正常  1 告警)
     */
    @TableField("DO2")
    private Integer do2;

    /**
     * 备用遥信1(0 正常  1 告警)
     */
    @TableField("ResDI1")
    private Integer ResDI1;

    /**
     * 备用遥信2(0 正常  1 告警)
     */
    @TableField("ResDI2")
    private Integer ResDI2;

    /**
     * 备用遥信3(0 正常  1 告警)
     */
    @TableField("ResDI3")
    private Integer ResDI3;

    /**
     * A相燃弧(0 正常  1 告警)
     */
    @TableField("ArcA")
    private Integer ArcA;

    /**
     * B相燃弧(0 正常  1 告警)
     */
    @TableField("ArcB")
    private Integer ArcB;

    /**
     * C相燃弧(0 正常  1 告警)
     */
    @TableField("ArcC")
    private Integer ArcC;

    /**
     * 母线停电(0 正常  1 告警)
     */
    @TableField("BusOutage")
    private Integer BusOutage;

    /**
     * 开入3(0 正常  1 告警)
     */
    @TableField("DI3")
    private Integer di3;

    /**
     * 设备异常(0 正常  1 告警)
     */
    @TableField("DevAbnormal")
    private Integer DevAbnormal;

    /**
     * 线路电气故障总(0 正常  1 告警)
     */
    @TableField("EleAlarm")
    private Integer EleAlarm;

    /**
     * 火灾预警总(0 正常  1 告警)
     */
    @TableField("FireAlarm")
    private Integer FireAlarm;

    /**
     * 线路开关状态(0 正常  1 告警)
     */
    @TableField("LoadBrkState")
    private Integer LoadBrkState;

    /**
     * 测量通道故障(0 正常  1 告警)
     */
    @TableField("MeasFailure")
    private Integer MeasFailure;

    /**
     * 消音(0 正常  1 告警)
     */
    @TableField("Mute")
    private Integer Mute;

    /**
     * 视在需量超限(0 正常  1 告警)
     */
    @TableField("OverDemandS")
    private Integer OverDemandS;

    /**
     * 环境温度越限(0 正常  1 告警)
     */
    @TableField("OverEvT")
    private Integer OverEvT;

    /**
     * 电流谐波越限(0 正常  1 告警)
     */
    @TableField("OverIH")
    private Integer OverIH;

    /**
     * 测温点4超温(0 正常  1 告警)
     */
    @TableField("OverT4")
    private Integer OverT4;

    /**
     * 电压谐波越限(0 正常  1 告警)
     */
    @TableField("OverUH")
    private Integer OverUH;

    /**
     * 过压(0 正常  1 告警)
     */
    @TableField("OverV")
    private Integer OverV;

    /**
     * 备用遥信4(0 正常  1 告警)
     */
    @TableField("ResDI4")
    private Integer ResDI4;

    private Integer idd;

    private String variableCoding;
}
