package com.bizmatics.model.vo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;

/**
 * <p>
 *
 * </p>
 *
 * @author ya
 * @since 2021-07-07
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class SingleLoopReportVo implements Serializable {

    /**
     * 伍继电力test_183消费组模拟量数据表ID
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 设备编号
     */
    private String deviceCode;

    /**
     * 设备名称
     */
    private String deviceName;

    /**
     * 功率因素
     */
    private Double cos;

    /**
     * 频率（平均）
     */
    private Double avgF;

    /**
     * 频率（最大）
     */
    private Double maxF;

    /**
     * 频率（最小）
     */
    private Double minF;

    /**
     * A相电流（平均）
     */
    private Double avgIa;

    /**
     * B相电流（平均）
     */
    private Double avgIb;

    /**
     * C相电流（平均）
     */
    private Double avgIc;

    /**
     * A相电流（最大）
     */
    private Double maxIa;

    /**
     * B相电流（最大）
     */
    private Double maxIb;

    /**
     * C相电流（最大）
     */
    private Double maxIc;

    /**
     * A相电流（最小）
     */
    private Double minIa;

    /**
     * B相电流（最小）
     */
    private Double minIb;

    /**
     * C相电流（最小）
     */
    private Double minIc;

    /**
     * A相电压（平均）
     */
    private Double avgUa;

    /**
     * B相电压（平均）
     */
    private Double avgUb;

    /**
     * C相电压（平均）
     */
    private Double avgUc;

    /**
     * A相电压（最大）
     */
    private Double maxUa;

    /**
     * B相电压（最大）
     */
    private Double maxUb;

    /**
     * C相电压（最大）
     */
    private Double maxUc;

    /**
     * A相电压（最小）
     */
    private Double minUa;

    /**
     * B相电压（最小）
     */
    private Double minUb;

    /**
     * C相电压（最小）
     */
    private Double minUc;

    /**
     * 电压等级
     */
    private String voltageLevel;

    /**
     * 额定电流（A）
     */
    private Double ratedCurrent;

    /**
     * 上报总数
     */
    private Integer measuringPoints;

    /**
     * 电流不平衡（平均）
     */
    private Double avgElBalun;
    /**
     * 电压不平衡（平均）
     */
    private Double avgVtBalun;

    /**
     * 电流不平衡（最大）
     */
    private Double maxElBalun;
    /**
     * 电压不平衡（最大）
     */
    private Double maxVtBalun;

    /**
     * 电流不平衡（最小）
     */
    private Double minElBalun;
    /**
     * 电压不平衡（最小）
     */
    private Double minVtBalun;

    /**
     * A相电压比例
     */
    private String proportionUa;

    /**
     * A相电压合格率
     */
    private Double qrUa;

    /**
     * B相电压比例
     */
    private String proportionUb;

    /**
     * B相电压合格率
     */
    private Double qrUb;

    /**
     * C相电压比例
     */
    private String proportionUc;

    /**
     * C相电压合格率
     */
    private Double qrUc;

    /**
     * 频率比例
     */
    private String proportionF;

    /**
     * 频率合格率
     */
    private Double qrF;

    /**
     * 电流不平衡度比例
     */
    private String proportionElBalun;

    /**
     * 电流不平衡度合格率
     */
    private Double qrElBalun;

    /**
     * 电压不平衡度比例
     */
    private String proportionVtBalun;

    /**
     * 电压不平衡度合格率
     */
    private Double qrVtBalun;


    /**
     * 标称电压上限
     */
    private Double voltageLevelToplimit;

    /**
     * 标称电压下限
     */
    private Double voltageLevelLowerLimit;

    /**
     * 标称频率
     */
    private Double mhz;

    /**
     * 频率上限
     */
    private Double fToplimit;

    /**
     * 频率下限
     */
    private Double fLowerLimit;

    /**
     * 考核限值
     */
    private Double appraise;
    /**
     * 不平衡度上限
     */
    private Double balanceToplimit;
    /**
     * 不平衡度下限
     */
    private Double balanceLowerLimit;
}
