package com.bizmatics.model.vo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 *
 * </p>
 *
 * @author ya
 * @since 2021-07-07
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class SiteData implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 站点表ID
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 站点名称
     */
    private String siteName;

    /**
     * 站点位置
     */
    private String siteAddress;

    /**
     * 手机号码1
     */
    private String phone;

    /**
     * 手机号码2
     */
    private String sparePhone;

    /**
     * 装机容量
     */
    private String installedCapacity;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 供电类型:1\\单路、2\\双路
     */
    private Integer powerSupplyType;

    /**
     * 电压等级（单位：V）
     */
    private String voltageLevel;

    /**
     * 投运时间
     */
    private Date operationTime;

}
