package com.bizmatics.persistence.mapper;

import com.bizmatics.common.mvc.base.CrudMapper;
import com.bizmatics.model.PlatformArea;
import com.bizmatics.model.vo.PlatformAreaVo;
import com.bizmatics.model.vo.SiteListVo;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author ya
 * @since 2021-09-29
 */
public interface PlatformAreaMapper extends CrudMapper<PlatformArea> {

    List<PlatformAreaVo> siteCount(@Param("platformAreaName") String platformAreaName,
                                   @Param("startCurrent") Integer startCurrent,
                                   @Param("size") Integer size,
                                   @Param("tenantId") Integer tenantId);

    int platformSiteCount(@Param("platformAreaName") String platformAreaName,
                          @Param("startCurrent") Integer startCurrent,
                          @Param("size") Integer size,
                          @Param("tenantId") Integer tenantId);

    List<PlatformAreaVo> deviceCount(@Param("platformAreaName") String platformAreaName,
                                     @Param("tenantId") Integer tenantId);

    List<SiteListVo> deviceList(@Param("stationAreaId") int stationAreaId);

    List<PlatformAreaVo> selectOne(@Param("stationAreaId") int stationAreaId);

}
