package com.bizmatics.persistence.mapper;

import com.bizmatics.common.mvc.base.CrudMapper;
import com.bizmatics.model.*;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author ya
 * @since 2021-07-07
 */
@Repository
public interface SiteMapper extends CrudMapper<Site> {


    int selectCount(@Param("userId") Integer userId,
                    @Param("siteId") Integer siteId,
                    @Param("siteStatus") Integer siteStatus);

    List<Site> list(@Param("userId") Integer userId,
                    @Param("name") String name,
                    @Param("tenantId") Integer tenantId);

    List<Site> listOne(@Param("name") String name,
                       @Param("tenantId") Integer tenantId);

    List<SiteTwo> list2(@Param("userId") Integer userId,
                        @Param("name") String name,
                        @Param("stationAreaId") Integer stationAreaId);


    List<Device> getDeviceListOne(@Param("siteId") Integer siteId);


    List<Site> idList(@Param("userId") Integer userId,
                      @Param("name") String name);

    List<SiteList> Sitelist(@Param("userId") Integer userId,
                            @Param("name") String name,
                            @Param("tenantId") Integer tenantId);

    List<SiteList> SitelistOne(@Param("name") String name,
                               @Param("tenantId") Integer tenantId);

    List<GroupingList> GroupingList(@Param("name") String name,
                                    @Param("creator") String creator,
                                    @Param("tenantId") Integer tenantId);

    List<GroupingList> GroupingListOne(@Param("name") String name,
                                       @Param("userId") Integer userId,
                                       @Param("tenantId") Integer tenantId);

    List<GroupingList> GroupingListTwo(@Param("creator") String creator);

    List<SiteList> SiteGroupinglist(@Param("userId") Integer userId,
                                    @Param("name") String name,
                                    @Param("tenantId") Integer tenantId);


    List<TemplateData> templateQuery(@Param("id") Integer id);

    List<Site> list1(@Param("id") Integer id);

    List<SiteDynamicProperties> SiteDynamicPropertieslist(@Param("siteId") Integer siteId);

    List<DeviceAnalogVariableList> deviceAnalogVariableList(@Param("siteId") Integer siteId,
                                                            @Param("dataArea") Integer dataArea);
}
