package com.bizmatics.persistence.mapper;

import com.bizmatics.model.SysPlatform;
import com.bizmatics.common.mvc.base.CrudMapper;
import com.bizmatics.model.SysPlatformMenu;
import com.bizmatics.model.system.SysMenu;
import com.bizmatics.model.vo.SysPlatformVo;
import com.bizmatics.model.vo.SysTenantTwoVo;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * <p>
 * 平台信息表 Mapper 接口
 * </p>
 *
 * @author ya
 * @since 2022-05-18
 */
public interface SysPlatformMapper extends CrudMapper<SysPlatform> {

    List<SysPlatformVo> getPlatformList(@Param("platformName") String platformName,
                                        @Param("startTime") String startTime,
                                        @Param("endTime") String endTime,
                                        @Param("current") Integer current,
                                        @Param("size") Integer size,
                                        @Param("id") Integer id);

    List<SysMenu> getMenuIdListOne(Long[] menuIds, String menuType);

    int deletePlatformMenuBy(Long platformId);


    List<SysPlatformMenu> getMenuListOne(Long platformId, String menuType);
}
