package com.bizmatics.service.impl;

import com.bizmatics.common.core.bean.CommonPage;
import com.bizmatics.common.mvc.base.AbstractCrudService;
import com.bizmatics.model.SysLoginLog;
import com.bizmatics.model.vo.SysLoginLogVo;
import com.bizmatics.persistence.mapper.SysLoginLogMapper;
import com.bizmatics.service.SysLoginLogService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 系统访问记录 服务实现类
 * </p>
 *
 * @author ya
 * @since 2022-06-02
 */
@Service
public class SysLoginLogServiceImpl extends AbstractCrudService<SysLoginLogMapper, SysLoginLog> implements SysLoginLogService {

    @Override
    public CommonPage<SysLoginLogVo> getLoginLogList(String ipaddr, String userName, String nickName, Integer status, String startTime, String endTime, Integer page, Integer size) {
        Integer total = baseMapper.getLoginLogCount(ipaddr, userName, nickName, status, startTime, endTime);
        Integer current = null;
        if (page != null && size > 0) {
            current = (page - 1) * size;
        }
        List<SysLoginLogVo> list = baseMapper.getLoginLogList(ipaddr, userName, nickName, status, startTime, endTime, current, size);
        return new CommonPage<>(list, total, size, page);
    }

}
