package com.bizmatics.service.util;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.bizmatics.common.core.util.HttpUtils;
import com.bizmatics.common.core.util.StringUtils;
import com.bizmatics.common.mvc.utils.IpUtils;
import com.bizmatics.common.spring.util.JsonUtils;
import com.bizmatics.model.vo.ContextualDataVo;
import com.bizmatics.model.vo.HtAnalogDataVo;
import com.bizmatics.model.vo.RtAnalogDataOneVo;
import com.bizmatics.model.vo.RtSwitchDataVo;
import com.bizmatics.service.config.WjConfig;
import com.fasterxml.jackson.core.type.TypeReference;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.lang.reflect.Field;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.*;

/**
 * 伍继电力字段转义
 * 
 * @author yq
 */
public class FieldEscapeUtils
{

    public static String getLastDayOfMonth(String yearMonth) {
        int year = Integer.parseInt(yearMonth.split("-")[0]);  //年
        int month = Integer.parseInt(yearMonth.split("-")[1]); //月
        Calendar cal = Calendar.getInstance();
        // 设置年份
        cal.set(Calendar.YEAR, year);
        // 设置月份
        // cal.set(Calendar.MONTH, month - 1);
        cal.set(Calendar.MONTH, month); //设置当前月的上一个月
        // 获取某月最大天数
        //int lastDay = cal.getActualMaximum(Calendar.DATE);
        int lastDay = cal.getMinimum(Calendar.DATE); //获取月份中的最小值，即第一天
        // 设置日历中月份的最大天数
        //cal.set(Calendar.DAY_OF_MONTH, lastDay);
        cal.set(Calendar.DAY_OF_MONTH, lastDay - 1); //上月的第一天减去1就是当月的最后一天
        // 格式化日期
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        return sdf.format(cal.getTime());
    }

    public static void remove1(List<String> list) {
        Iterator<String> sListIterator = list.iterator();
        while (sListIterator.hasNext()) {
            String str = sListIterator.next();
            if (str.contains("dataTime")) {
                sListIterator.remove();
            }
        }
    }

   public static String fieldEscapeUtils(String fieldValue){
       String field=null;
       switch (fieldValue) {
           case "Busot":
               field = "母线停电次数";
               break;
           case "COS":
               field = "三相功率因数";
               break;
           case "COSa":
               field = "A相功率因数";
               break;
           case "COSb":
               field = "B相功率因数";
               break;
           case "COSc":
               field = "C相功率因数";
               break;
           case "Demand":
               field = "实时有功需量";
               break;
           case "DevResetTimes":
               field = "设备复位次数";
               break;
           case "DeviceTemp":
               field = "设备温度";
               break;
           case "Epn":
               field = "三相反向有功电度";
               break;
           case "Epn1":
               field = "尖段反向有功电度";
               break;
           case "Epn2":
               field = "峰段反向有功电度";
               break;
           case "Epn3":
               field = "平段反向有功电度";
               break;
           case "Epn4":
               field = "谷段反向有功电度";
               break;
           case "Epp":
               field = "三相正向有功电度";
               break;
           case "Epp1":
               field = "尖段正向有功电度";
               break;
           case "Epp2":
               field = "峰段正向有功电度";
               break;
           case "Epp3":
               field = "平段正向有功电度";
               break;
           case "Epp4":
               field = "谷段正向有功电度";
               break;
           case "Eqn":
               field = "三相反向无功电度";
               break;
           case "Eqp":
               field = "三相正向无功电度";
               break;
           case "F":
               field = "频率";
               break;
           case "I0":
               field = "零序电流";
               break;
           case "I2":
               field = "负序电流";
               break;
           case "IHa":
               field = "A相总谐波电流";
               break;
           case "IHb":
               field = "B相总谐波电流";
               break;
           case "IHc":
               field = "C相总谐波电流";
               break;
           case "Ia":
               field = "A相电流";
               break;
           case "Ib":
               field = "B相电流";
               break;
           case "Ic":
               field = "C相电流";
               break;
           case "Ir":
               field = "剩余电流";
               break;
           case "LastDayMD":
               field = "昨日有功最大需量";
               break;
           case "LastDayMDt":
               field = "昨日有功最大需量发生时间";
               break;
           case "P":
               field = "三相总有功功率";
               break;
           case "Pa":
               field = "A相有功功率";
               break;
           case "Pb":
               field = "B相有功功率";
               break;
           case "Pc":
               field = "C相有功功率";
               break;
           case "Q":
               field = "三相总无功功率";
               break;
           case "Qa":
               field = "A相无功功率";
               break;
           case "Qb":
               field = "B相无功功率";
               break;
           case "Qc":
               field = "C相无功功率";
               break;
           case "SignalIntensity":
               field = "信号强度";
               break;
           case "T1":
               field = "第1路温度";
               break;
           case "T2":
               field = "第2路温度";
               break;
           case "T3":
               field = "第3路温度";
               break;
           case "T4":
               field = "第4路温度";
               break;
           case "THDUa":
               field = "A相电压THD";
               break;
           case "THDUb":
               field = "B相电压THD";
               break;
           case "THDUc":
               field = "C相电压THD";
               break;
           case "Ua":
               field = "A相电压";
               break;
           case "Uab":
               field = "AB线电压";
               break;
           case "Ub":
               field = "B相电压";
               break;
           case "Ubc":
               field = "BC线电压";
               break;
           case "UblU0":
               field = "零序电压不平衡度";
               break;
           case "UblU2":
               field = "负序电压不平衡度";
               break;
           case "Uc":
               field = "C相电压";
               break;
           case "Uca":
               field = "CA线电压";
               break;
           case "Udt":
               field = "电压暂降次数";
               break;
           case "Ul":
               field = "线路侧电压";
               break;
           case "Upt":
               field = "电压暂升次数";
               break;
           case "Ust":
               field = "电压短时中断次数";
               break;
           case "voltageA":
               field = "A相电压";
               break;
           case "voltageB":
               field = "B相电压";
               break;
           case "voltageC":
               field = "C相电压";
               break;
           case "voltageAB":
               field = "AB线电压";
               break;
           case "voltageBC":
               field = "BC线电压";
               break;
           case "voltageCA":
               field = "CA线电压";
               break;
           case "frequency":
               field = "频率";
               break;
           case "analog1":
               field = "直流遥测1";
               break;
           case "analog2":
               field = "直流遥测2";
               break;
           case "analog3":
               field = "直流遥测3";
               break;
           case "analog4":
               field = "直流遥测4";
               break;
           case "analog5":
               field = "直流遥测5";
               break;
           case "voltageATHD":
               field = "A相电压THD";
               break;
           case "voltageBTHD":
               field = "B相电压THD";
               break;
           case "voltageCTHD":
               field = "C相电压THD";
               break;
           case "voltageSagTimes":
               field = "电压暂降次数";
               break;
           case "voltageSwellTimes":
               field = "电压暂升次数";
               break;
           case "voltageInterruptionTimes":
               field = "电压中断次数";
               break;
           case "voltageUnbalanceFactor":
               field = "电压不平衡度";
               break;
           case "analogReserved":
               field = "遥测备用";
               break;
           case "freezingTime":
               field = "冻结时间";
               break;
           case "unbalanceCurrent":
               field = "不平衡电流";
               break;
           case "unbalanceVoltage":
               field = "不平衡电压";
               break;
           case "analogReserved1":
               field = "遥测备用1";
               break;
           case "analogReserved2":
               field = "遥测备用2";
               break;
           case "analogReserved3":
               field = "遥测备用3";
               break;
           case "analogReserved4":
               field = "遥测备用4";
               break;
           default:
               field = "未定义";
       }
       return field;
   }


   public static Object transformation(HtAnalogDataVo htAnalogDataVo,String fieldValue){

       switch (fieldValue) {
           case "Busot":
               return htAnalogDataVo.getBusot();
//               break;
           case "COS":
               return htAnalogDataVo.getCos();
//               break;
           case "COSa":
               return htAnalogDataVo.getCOSa();
//               break;
           case "COSb":
               return htAnalogDataVo.getCOSb();
//               break;
           case "COSc":
               return htAnalogDataVo.getCOSc();
//               break;
           case "Demand":
               return htAnalogDataVo.getDemand();
//               break;
           case "DevResetTimes":
               return htAnalogDataVo.getDevResetTimes();
//               break;
           case "DeviceTemp":
               return htAnalogDataVo.getDeviceTemp();
//               break;
           case "Epn":
               return htAnalogDataVo.getEpn();
//               break;
           case "Epn1":
               return htAnalogDataVo.getEpn1();
//               break;
           case "Epn2":
               return htAnalogDataVo.getEpn2();
//               break;
           case "Epn3":
               return htAnalogDataVo.getEpn3();
//               break;
           case "Epn4":
               return htAnalogDataVo.getEpn4();
//               break;
           case "Epp":
               return htAnalogDataVo.getEpp();
//               break;
           case "Epp1":
               return htAnalogDataVo.getEpp1();
//               break;
           case "Epp2":
               return htAnalogDataVo.getEpp2();
//               break;
           case "Epp3":
               return htAnalogDataVo.getEpp3();
//               break;
           case "Epp4":
               return htAnalogDataVo.getEpp4();
//               break;
           case "Eqn":
               return htAnalogDataVo.getEqn();
//               break;
           case "Eqp":
               return htAnalogDataVo.getEqp();
//               break;
           case "F":
               return htAnalogDataVo.getF();
//               break;
           case "I0":
               return htAnalogDataVo.getI0();
//               break;
           case "I2":
               return htAnalogDataVo.getI2();
//               break;
           case "IHa":
               return htAnalogDataVo.getIHa();
//               break;
           case "IHb":
               return htAnalogDataVo.getIHb();
//               break;
           case "IHc":
               return htAnalogDataVo.getIHc();
//               break;
           case "Ia":
               return htAnalogDataVo.getIa();
//               break;
           case "Ib":
               return htAnalogDataVo.getIb();
//               break;
           case "Ic":
               return htAnalogDataVo.getIc();
//               break;
           case "Ir":
               return htAnalogDataVo.getIr();
//               break;
           case "LastDayMD":
               return htAnalogDataVo.getLastDayMD();
//               break;
           case "LastDayMDt":
               return htAnalogDataVo.getLastDayMDt();
//               break;
           case "P":
               return htAnalogDataVo.getP();
//               break;
           case "Pa":
               return htAnalogDataVo.getPa();
//               break;
           case "Pb":
               return htAnalogDataVo.getPb();
//               break;
           case "Pc":
               return htAnalogDataVo.getPc();
//               break;
           case "Q":
               return htAnalogDataVo.getQ();
//               break;
           case "Qa":
               return htAnalogDataVo.getQa();
//               break;
           case "Qb":
               return htAnalogDataVo.getQb();
//               break;
           case "Qc":
               return htAnalogDataVo.getQc();
//               break;
           case "SignalIntensity":
               return htAnalogDataVo.getSignalIntensity();
//               break;
           case "T1":
               return htAnalogDataVo.getT1();
//               break;
           case "T2":
               return htAnalogDataVo.getT2();
//               break;
           case "T3":
               return htAnalogDataVo.getT3();
//               break;
           case "T4":
               return htAnalogDataVo.getT4();
//               break;
           case "THDUa":
               return htAnalogDataVo.getTHDUa();
//               break;
           case "THDUb":
               return htAnalogDataVo.getTHDUb();
//               break;
           case "THDUc":
               return htAnalogDataVo.getTHDUc();
//               break;
           case "Ua":
               return htAnalogDataVo.getUa();
//               break;
           case "Uab":
               return htAnalogDataVo.getUab();
//               break;
           case "Ub":
               return htAnalogDataVo.getUb();
//               break;
           case "Ubc":
               return htAnalogDataVo.getUbc();
//               break;
           case "UblU0":
               return htAnalogDataVo.getUblU0();
//               break;
           case "UblU2":
               return htAnalogDataVo.getUblU2();
//               break;
           case "Uc":
               return htAnalogDataVo.getUc();
//               break;
           case "Uca":
               return htAnalogDataVo.getUca();
//               break;
           case "Udt":
               return htAnalogDataVo.getUdt();
//               break;
           case "Ul":
               return htAnalogDataVo.getUl();
//               break;
           case "Upt":
               return htAnalogDataVo.getUpt();
//               break;
           case "Ust":
               return htAnalogDataVo.getUst();
//               break;
           default:
               return null;
       }
   }


    public static Object transformation1(ContextualDataVo contextualDataVo, String fieldValue){
        switch (fieldValue) {
            case "Busot":
                return contextualDataVo.getBusot();
            case "COS":
                return contextualDataVo.getCos();
            case "COSa":
                return contextualDataVo.getCOSa();
            case "COSb":
                return contextualDataVo.getCOSb();
            case "COSc":
                return contextualDataVo.getCOSc();
            case "Demand":
                return contextualDataVo.getDemand();
            case "DevResetTimes":
                return contextualDataVo.getDevResetTimes();
            case "DeviceTemp":
                return contextualDataVo.getDeviceTemp();
            case "Epn":
                return contextualDataVo.getEpn();
            case "Epn1":
                return contextualDataVo.getEpn1();
            case "Epn2":
                return contextualDataVo.getEpn2();
            case "Epn3":
                return contextualDataVo.getEpn3();
            case "Epn4":
                return contextualDataVo.getEpn4();
            case "Epp":
                return contextualDataVo.getEpp();
            case "Epp1":
                return contextualDataVo.getEpp1();
            case "Epp2":
                return contextualDataVo.getEpp2();
            case "Epp3":
                return contextualDataVo.getEpp3();
            case "Epp4":
                return contextualDataVo.getEpp4();
            case "Eqn":
                return contextualDataVo.getEqn();
            case "Eqp":
                return contextualDataVo.getEqp();
            case "F":
                return contextualDataVo.getF();
            case "I0":
                return contextualDataVo.getI0();
            case "I2":
                return contextualDataVo.getI2();
            case "IHa":
                return contextualDataVo.getIHa();
            case "IHb":
                return contextualDataVo.getIHb();
            case "IHc":
                return contextualDataVo.getIHc();
            case "Ia":
                return contextualDataVo.getIa();
            case "Ib":
                return contextualDataVo.getIb();
            case "Ic":
                return contextualDataVo.getIc();
            case "Ir":
                return contextualDataVo.getIr();
            case "LastDayMD":
                return contextualDataVo.getLastDayMD();
            case "LastDayMDt":
                return contextualDataVo.getLastDayMDt();
            case "P":
                return contextualDataVo.getP();
            case "Pa":
                return contextualDataVo.getPa();
            case "Pb":
                return contextualDataVo.getPb();
            case "Pc":
                return contextualDataVo.getPc();
            case "Q":
                return contextualDataVo.getQ();
            case "Qa":
                return contextualDataVo.getQa();
            case "Qb":
                return contextualDataVo.getQb();
            case "Qc":
                return contextualDataVo.getQc();
            case "SignalIntensity":
                return contextualDataVo.getSignalIntensity();
            case "T1":
                return contextualDataVo.getT1();
            case "T2":
                return contextualDataVo.getT2();
            case "T3":
                return contextualDataVo.getT3();
            case "T4":
                return contextualDataVo.getT4();
            case "THDUa":
                return contextualDataVo.getTHDUa();
            case "THDUb":
                return contextualDataVo.getTHDUb();
            case "THDUc":
                return contextualDataVo.getTHDUc();
            case "Ua":
                return contextualDataVo.getUa();
            case "Uab":
                return contextualDataVo.getUab();
            case "Ub":
                return contextualDataVo.getUb();
            case "Ubc":
                return contextualDataVo.getUbc();
            case "UblU0":
                return contextualDataVo.getUblU0();
            case "UblU2":
                return contextualDataVo.getUblU2();
            case "Uc":
                return contextualDataVo.getUc();
            case "Uca":
                return contextualDataVo.getUca();
            case "Udt":
                return contextualDataVo.getUdt();
            case "Ul":
                return contextualDataVo.getUl();
            case "Upt":
                return contextualDataVo.getUpt();
            case "Ust":
                return contextualDataVo.getUst();
            case "voltageA":
                return contextualDataVo.getVoltageA();
            case "voltageB":
                return contextualDataVo.getVoltageB();
            case "voltageC":
                return contextualDataVo.getVoltageC();
            case "voltageAB":
                return contextualDataVo.getVoltageAB();
            case "voltageBC":
                return contextualDataVo.getVoltageBC();
            case "voltageCA":
                return contextualDataVo.getVoltageCA();
            case "frequency":
                return contextualDataVo.getFrequency();
            case "analog1":
                return contextualDataVo.getAnalog1();
            case "analog2":
                return contextualDataVo.getAnalog2();
            case "analog3":
                return contextualDataVo.getAnalog3();
            case "analog4":
                return contextualDataVo.getAnalog4();
            case "analog5":
                return contextualDataVo.getAnalog5();
            case "voltageATHD":
                return contextualDataVo.getVoltageATHD();
            case "voltageBTHD":
                return contextualDataVo.getVoltageBTHD();
            case "voltageCTHD":
                return contextualDataVo.getVoltageCTHD();
            case "voltageSagTimes":
                return contextualDataVo.getVoltageSagTimes();
            case "voltageSwellTimes":
                return contextualDataVo.getVoltageSwellTimes();
            case "voltageInterruptionTimes":
                return contextualDataVo.getVoltageInterruptionTimes();
            case "voltageUnbalanceFactor":
                return contextualDataVo.getVoltageUnbalanceFactor();
            case "analogReserved":
                return contextualDataVo.getAnalogReserved();
            case "freezingTime":
                return contextualDataVo.getFreezingTime();
            case "unbalanceCurrent":
                return contextualDataVo.getUnbalanceCurrent();
            case "unbalanceVoltage":
                return contextualDataVo.getUnbalanceVoltage();
            case "analogReserved1":
                return contextualDataVo.getAnalogReserved1();
            case "analogReserved2":
                return contextualDataVo.getAnalogReserved2();
            case "analogReserved3":
                return contextualDataVo.getAnalogReserved3();
            case "analogReserved4":
                return contextualDataVo.getAnalogReserved4();
            default:
                return null;
        }
    }

    public  String getStringAbel(List<?> o, Class<?> c, String field) {
        StringBuffer result = new StringBuffer();
        if (StringUtils.isNoneBlank(field)) {
            Field[] fields = c.getDeclaredFields();
            int pos;
            for (pos = 0; pos < fields.length; pos++) {
                if (field.equals(fields[pos].getName())) {
                    break;
                }
            }
            for (Object o1 : o) {
                try {
                    fields[pos].setAccessible(true);
                    result.append(fields[pos].get(o1) + ",");
                } catch (Exception e) {
                    System.out.println("error--------" + "Reason is:" + e.getMessage());
                }
            }
        }
        return result.deleteCharAt(result.length() - 1).toString();
    }



    public static String getVariableValue(RtAnalogDataOneVo rtAnalogDataOneVo){
        String[] arr = rtAnalogDataOneVo.getVariableCoding().split("_");
        int arrlength = arr.length;
        String variableValue = null;
        if (arr[arrlength-1].equals("Busot")){
            variableValue=""+rtAnalogDataOneVo.getBusot();
        }else if (arr[arrlength-1].equals("COS")){
            variableValue=""+rtAnalogDataOneVo.getCos();
        }else if (arr[arrlength-1].equals("COSa")){
            variableValue=""+rtAnalogDataOneVo.getCOSa();
        }else if (arr[arrlength-1].equals("COSb")){
            variableValue=""+rtAnalogDataOneVo.getCOSb();
        }else if (arr[arrlength-1].equals("COSc")){
            variableValue=""+rtAnalogDataOneVo.getCOSc();
        }else if (arr[arrlength-1].equals("Demand")){
            variableValue=""+rtAnalogDataOneVo.getDemand();
        }else if (arr[arrlength-1].equals("DevResetTimes")){
            variableValue=""+rtAnalogDataOneVo.getDevResetTimes();
        }else if (arr[arrlength-1].equals("DeviceTemp")){
            variableValue=""+rtAnalogDataOneVo.getDeviceTemp();
        }else if (arr[arrlength-1].equals("Epn")){
            variableValue=""+rtAnalogDataOneVo.getEpn();
        }else if (arr[arrlength-1].equals("Epn1")){
            variableValue=""+rtAnalogDataOneVo.getEpn1();
        }else if (arr[arrlength-1].equals("Epn2")){
            variableValue=""+rtAnalogDataOneVo.getEpn2();
        }else if (arr[arrlength-1].equals("Epn3")){
            variableValue=""+rtAnalogDataOneVo.getEpn3();
        }else if (arr[arrlength-1].equals("Epn4")){
            variableValue=""+rtAnalogDataOneVo.getEpn4();
        }else if (arr[arrlength-1].equals("Epp")){
            variableValue=""+rtAnalogDataOneVo.getEpp();
        }else if (arr[arrlength-1].equals("Epp1")){
            variableValue=""+rtAnalogDataOneVo.getEpp1();
        }else if (arr[arrlength-1].equals("Epp2")){
            variableValue=""+rtAnalogDataOneVo.getEpp2();
        }else if (arr[arrlength-1].equals("Epp3")){
            variableValue=""+rtAnalogDataOneVo.getEpp3();
        }else if (arr[arrlength-1].equals("Epp4")){
            variableValue=""+rtAnalogDataOneVo.getEpp4();
        }else if (arr[arrlength-1].equals("Eqn")){
            variableValue=""+rtAnalogDataOneVo.getEqn();
        }else if (arr[arrlength-1].equals("Eqp")){
            variableValue=""+rtAnalogDataOneVo.getEqp();
        }else if (arr[arrlength-1].equals("F")){
            variableValue=""+rtAnalogDataOneVo.getF();
        }else if (arr[arrlength-1].equals("I0")){
            variableValue=""+rtAnalogDataOneVo.getI0();
        }else if (arr[arrlength-1].equals("I2")){
            variableValue=""+rtAnalogDataOneVo.getI2();
        }else if (arr[arrlength-1].equals("IHa")){
            variableValue=""+rtAnalogDataOneVo.getIHa();
        }else if (arr[arrlength-1].equals("IHb")){
            variableValue=""+rtAnalogDataOneVo.getIHb();
        }else if (arr[arrlength-1].equals("IHc")){
            variableValue=""+rtAnalogDataOneVo.getIHc();
        }else if (arr[arrlength-1].equals("Ia")){
            variableValue=""+rtAnalogDataOneVo.getIa();
        }else if (arr[arrlength-1].equals("Ib")){
            variableValue=""+rtAnalogDataOneVo.getIb();
        }else if (arr[arrlength-1].equals("Ic")){
            variableValue=""+rtAnalogDataOneVo.getIc();
        }else if (arr[arrlength-1].equals("Ir")){
            variableValue=""+rtAnalogDataOneVo.getIr();
        }else if (arr[arrlength-1].equals("LastDayMD")){
            variableValue=""+rtAnalogDataOneVo.getLastDayMD();
        }else if (arr[arrlength-1].equals("LastDayMDt")){
            variableValue=""+rtAnalogDataOneVo.getLastDayMDt();
        }else if (arr[arrlength-1].equals("P")){
            variableValue=""+rtAnalogDataOneVo.getP();
        }else if (arr[arrlength-1].equals("Pa")){
            variableValue=""+rtAnalogDataOneVo.getPa();
        }else if (arr[arrlength-1].equals("Pb")){
            variableValue=""+rtAnalogDataOneVo.getPb();
        }else if (arr[arrlength-1].equals("Pc")){
            variableValue=""+rtAnalogDataOneVo.getPc();
        }else if (arr[arrlength-1].equals("Q")){
            variableValue=""+rtAnalogDataOneVo.getQ();
        }else if (arr[arrlength-1].equals("Qa")){
            variableValue=""+rtAnalogDataOneVo.getQa();
        }else if (arr[arrlength-1].equals("Qb")){
            variableValue=""+rtAnalogDataOneVo.getQb();
        }else if (arr[arrlength-1].equals("Qc")){
            variableValue=""+rtAnalogDataOneVo.getQc();
        }else if (arr[arrlength-1].equals("SignalIntensity")){
            variableValue = "" + rtAnalogDataOneVo.getSignalIntensity();
        }else if (arr[arrlength-1].equals("T1")){
            variableValue=""+rtAnalogDataOneVo.getT1();
        }else if (arr[arrlength-1].equals("T2")){
            variableValue=""+rtAnalogDataOneVo.getT2();
        }else if (arr[arrlength-1].equals("T3")){
            variableValue=""+rtAnalogDataOneVo.getT3();
        }else if (arr[arrlength-1].equals("T4")){
            variableValue=""+rtAnalogDataOneVo.getT4();
        }else if (arr[arrlength-1].equals("THDUa")){
            variableValue=""+rtAnalogDataOneVo.getTHDUa();
        }else if (arr[arrlength-1].equals("THDUb")){
            variableValue=""+rtAnalogDataOneVo.getTHDUb();
        }else if (arr[arrlength-1].equals("THDUc")){
            variableValue=""+rtAnalogDataOneVo.getTHDUc();
        }else if (arr[arrlength-1].equals("Ua")){
            variableValue=""+rtAnalogDataOneVo.getUa();
        }else if (arr[arrlength-1].equals("Uab")){
            variableValue=""+rtAnalogDataOneVo.getUab();
        }else if (arr[arrlength-1].equals("Ub")){
            variableValue=""+rtAnalogDataOneVo.getUb();
        }else if (arr[arrlength-1].equals("Ubc")){
            variableValue=""+rtAnalogDataOneVo.getUbc();
        }else if (arr[arrlength-1].equals("UblU0")){
            variableValue=""+rtAnalogDataOneVo.getUblU0();
        }else if (arr[arrlength-1].equals("UblU2")){
            variableValue=""+rtAnalogDataOneVo.getUblU2();
        }else if (arr[arrlength-1].equals("Uc")){
            variableValue=""+rtAnalogDataOneVo.getUc();
        }else if (arr[arrlength-1].equals("Uca")){
            variableValue=""+rtAnalogDataOneVo.getUca();
        }else if (arr[arrlength-1].equals("Udt")){
            variableValue=""+rtAnalogDataOneVo.getUdt();
        }else if (arr[arrlength-1].equals("Ul")){
            variableValue=""+rtAnalogDataOneVo.getUl();
        }else if (arr[arrlength-1].equals("Upt")){
            variableValue=""+rtAnalogDataOneVo.getUpt();
        }else if (arr[arrlength-1].equals("Ust")){
            variableValue=""+rtAnalogDataOneVo.getUst();
        }else if (arr[arrlength-1].equals("voltageA")){
            variableValue=""+rtAnalogDataOneVo.getVoltageA();
        }else if (arr[arrlength-1].equals("voltageB")){
            variableValue=""+rtAnalogDataOneVo.getVoltageB();
        }else if (arr[arrlength-1].equals("voltageC")){
            variableValue=""+rtAnalogDataOneVo.getVoltageC();
        }else if (arr[arrlength-1].equals("voltageAB")){
            variableValue=""+rtAnalogDataOneVo.getVoltageAB();
        }else if (arr[arrlength-1].equals("voltageBC")){
            variableValue=""+rtAnalogDataOneVo.getVoltageBC();
        }else if (arr[arrlength-1].equals("voltageCA")){
            variableValue=""+rtAnalogDataOneVo.getVoltageCA();
        }else if (arr[arrlength-1].equals("frequency")){
            variableValue=""+rtAnalogDataOneVo.getFrequency();
        }else if (arr[arrlength-1].equals("analog1")){
            variableValue=""+rtAnalogDataOneVo.getAnalog1();
        }else if (arr[arrlength-1].equals("analog2")){
            variableValue=""+rtAnalogDataOneVo.getAnalog2();
        }else if (arr[arrlength-1].equals("analog3")){
            variableValue=""+rtAnalogDataOneVo.getAnalog3();
        }else if (arr[arrlength-1].equals("analog4")){
            variableValue=""+rtAnalogDataOneVo.getAnalog4();
        }else if (arr[arrlength-1].equals("analog5")){
            variableValue=""+rtAnalogDataOneVo.getAnalog5();
        }else if (arr[arrlength-1].equals("voltageATHD")){
            variableValue=""+rtAnalogDataOneVo.getVoltageATHD();
        }else if (arr[arrlength-1].equals("voltageBTHD")){
            variableValue=""+rtAnalogDataOneVo.getVoltageBTHD();
        }else if (arr[arrlength-1].equals("voltageCTHD")){
            variableValue=""+rtAnalogDataOneVo.getVoltageCTHD();
        }else if (arr[arrlength-1].equals("voltageSagTimes")){
            variableValue=""+rtAnalogDataOneVo.getVoltageSagTimes();
        }else if (arr[arrlength-1].equals("voltageSwellTimes")){
            variableValue=""+rtAnalogDataOneVo.getVoltageSwellTimes();
        }else if (arr[arrlength-1].equals("voltageInterruptionTimes")){
            variableValue=""+rtAnalogDataOneVo.getVoltageInterruptionTimes();
        }else if (arr[arrlength-1].equals("voltageUnbalanceFactor")){
            variableValue=""+rtAnalogDataOneVo.getVoltageUnbalanceFactor();
        }else if (arr[arrlength-1].equals("analogReserved")){
            variableValue=""+rtAnalogDataOneVo.getAnalogReserved();
        }else if (arr[arrlength-1].equals("unbalanceCurrent")){
            variableValue=""+rtAnalogDataOneVo.getUnbalanceCurrent();
        }else if (arr[arrlength-1].equals("unbalanceVoltage")){
            variableValue=""+rtAnalogDataOneVo.getUnbalanceVoltage();
        }else if (arr[arrlength-1].equals("analogReserved1")){
            variableValue=""+rtAnalogDataOneVo.getAnalogReserved1();
        }else if (arr[arrlength-1].equals("analogReserved2")){
            variableValue=""+rtAnalogDataOneVo.getAnalogReserved2();
        }else if (arr[arrlength-1].equals("analogReserved3")){
            variableValue=""+rtAnalogDataOneVo.getAnalogReserved3();
        }else if (arr[arrlength-1].equals("analogReserved4")){
            variableValue=""+rtAnalogDataOneVo.getAnalogReserved4();
        }else if (arr[arrlength-1].equals("commState")){
            variableValue=""+rtAnalogDataOneVo.getCommState();
        }else if (arr[arrlength-1].equals("busLive")){
            variableValue=""+rtAnalogDataOneVo.getBusLive();
        }else if (arr[arrlength-1].equals("highVoltageAlarm")){
            variableValue=""+rtAnalogDataOneVo.getHighVoltageAlarm();
        }else if (arr[arrlength-1].equals("lowVoltageAlarm")){
            variableValue=""+rtAnalogDataOneVo.getLowVoltageAlarm();
        }else if (arr[arrlength-1].equals("busLackPhase")){
            variableValue=""+rtAnalogDataOneVo.getBusLackPhase();
        }else if (arr[arrlength-1].equals("analog1Alarm")){
            variableValue=""+rtAnalogDataOneVo.getAnalog1Alarm();
        }else if (arr[arrlength-1].equals("analog2Alarm")){
            variableValue=""+rtAnalogDataOneVo.getAnalog2Alarm();
        }else if (arr[arrlength-1].equals("analog3Alarm")){
            variableValue=""+rtAnalogDataOneVo.getAnalog3Alarm();
        }else if (arr[arrlength-1].equals("analog4Alarm")){
            variableValue=""+rtAnalogDataOneVo.getAnalog4Alarm();
        }else if (arr[arrlength-1].equals("analog5Alarm")){
            variableValue=""+rtAnalogDataOneVo.getAnalog5Alarm();
        }else if (arr[arrlength-1].equals("digitalReserved1")){
            variableValue=""+rtAnalogDataOneVo.getDigitalReserved1();
        }else if (arr[arrlength-1].equals("digitalReserved2")){
            variableValue=""+rtAnalogDataOneVo.getDigitalReserved2();
        }else if (arr[arrlength-1].equals("digitalReserved3")){
            variableValue=""+rtAnalogDataOneVo.getDigitalReserved3();
        }else if (arr[arrlength-1].equals("digitalReserved4")){
            variableValue=""+rtAnalogDataOneVo.getDigitalReserved4();
        }else if (arr[arrlength-1].equals("digitalReserved5")){
            variableValue=""+rtAnalogDataOneVo.getDigitalReserved5();
        }else if (arr[arrlength-1].equals("digitalReserved6")){
            variableValue=""+rtAnalogDataOneVo.getDigitalReserved6();
        }else if (arr[arrlength-1].equals("LoadLive")){
            variableValue=""+rtAnalogDataOneVo.getLoadLive();
        }else if (arr[arrlength-1].equals("Trip")){
            variableValue=""+rtAnalogDataOneVo.getTrip();
        }else if (arr[arrlength-1].equals("OverI")){
            variableValue=""+rtAnalogDataOneVo.getOverI();
        }else if (arr[arrlength-1].equals("PhaseLoss")){
            variableValue=""+rtAnalogDataOneVo.getPhaseLoss();
        }else if (arr[arrlength-1].equals("UnderV")){
            variableValue=""+rtAnalogDataOneVo.getUnderV();
        }else if (arr[arrlength-1].equals("OverDemandP")){
            variableValue=""+rtAnalogDataOneVo.getOverDemandP();
        }else if (arr[arrlength-1].equals("OverIr")){
            variableValue=""+rtAnalogDataOneVo.getOverIr();
        }else if (arr[arrlength-1].equals("OverT1")){
            variableValue=""+rtAnalogDataOneVo.getOverT1();
        }else if (arr[arrlength-1].equals("OverT2")){
            variableValue=""+rtAnalogDataOneVo.getOverT2();
        }else if (arr[arrlength-1].equals("OverT3")){
            variableValue=""+rtAnalogDataOneVo.getOverT3();
        }else if (arr[arrlength-1].equals("DI1")){
            variableValue=""+rtAnalogDataOneVo.getDi1();
        }else if (arr[arrlength-1].equals("DI2")){
            variableValue=""+rtAnalogDataOneVo.getDi2();
        }else if (arr[arrlength-1].equals("DO1")){
            variableValue=""+rtAnalogDataOneVo.getDo1();
        }else if (arr[arrlength-1].equals("DO2")){
            variableValue=""+rtAnalogDataOneVo.getDo2();
        }else if (arr[arrlength-1].equals("ResDI1")){
            variableValue=""+rtAnalogDataOneVo.getResDI1();
        }else if (arr[arrlength-1].equals("ResDI2")){
            variableValue=""+rtAnalogDataOneVo.getResDI2();
        }else if (arr[arrlength-1].equals("ResDI3")){
            variableValue=""+rtAnalogDataOneVo.getResDI3();
        }else if (arr[arrlength-1].equals("ArcA")){
            variableValue=""+rtAnalogDataOneVo.getArcA();
        }else if (arr[arrlength-1].equals("ArcB")){
            variableValue=""+rtAnalogDataOneVo.getArcB();
        }else if (arr[arrlength-1].equals("ArcC")){
            variableValue=""+rtAnalogDataOneVo.getArcC();
        }else if (arr[arrlength-1].equals("BusOutage")){
            variableValue=""+rtAnalogDataOneVo.getBusOutage();
        }else if (arr[arrlength-1].equals("DI3")){
            variableValue=""+rtAnalogDataOneVo.getDi3();
        }else if (arr[arrlength-1].equals("DevAbnormal")){
            variableValue=""+rtAnalogDataOneVo.getDevAbnormal();
        }else if (arr[arrlength-1].equals("EleAlarm")){
            variableValue=""+rtAnalogDataOneVo.getEleAlarm();
        }else if (arr[arrlength-1].equals("FireAlarm")){
            variableValue=""+rtAnalogDataOneVo.getFireAlarm();
        }else if (arr[arrlength-1].equals("LoadBrkState")){
            variableValue=""+rtAnalogDataOneVo.getLoadBrkState();
        }else if (arr[arrlength-1].equals("MeasFailure")){
            variableValue=""+rtAnalogDataOneVo.getMeasFailure();
        }else if (arr[arrlength-1].equals("Mute")){
            variableValue=""+rtAnalogDataOneVo.getMute();
        }else if (arr[arrlength-1].equals("OverDemandS")){
            variableValue=""+rtAnalogDataOneVo.getOverDemandS();
        }else if (arr[arrlength-1].equals("OverEvT")){
            variableValue=""+rtAnalogDataOneVo.getOverEvT();
        }else if (arr[arrlength-1].equals("OverIH")){
            variableValue=""+rtAnalogDataOneVo.getOverIH();
        }else if (arr[arrlength-1].equals("OverT4")){
            variableValue=""+rtAnalogDataOneVo.getOverT4();
        }else if (arr[arrlength-1].equals("OverUH")){
            variableValue=""+rtAnalogDataOneVo.getOverUH();
        }else if (arr[arrlength-1].equals("OverV")){
            variableValue=""+rtAnalogDataOneVo.getOverV();
        }else if (arr[arrlength-1].equals("ResDI4")){
            variableValue=""+rtAnalogDataOneVo.getResDI4();
        }else {
            variableValue = null;
        }
        return variableValue;
    }


    public static List<String> getSyllable(Integer type, Integer valueCalculation, List<String> fieldDisplay){
        List<String> fieldDisplayOne = new ArrayList();
        if (type == 1) {
            fieldDisplayOne.add("a.id");
            fieldDisplayOne.add("a.deviceName");
            fieldDisplayOne.add("FROM_UNIXTIME(UNIX_TIMESTAMP(a.dataTime), '%Y-%m-%d') AS freezingTimes");
            fieldDisplayOne.add("a.dataTime");
            fieldDisplayOne.add("d.monitor_device_name");
            fieldDisplayOne.add("d.id as device_attribute_id");
            if (valueCalculation == 1) {
                for (int i=0;  i < fieldDisplay.size(); i++){
                    if (!fieldDisplay.get(i).equals("dataTime")){
                        fieldDisplayOne.add("AVG(a."+fieldDisplay.get(i)+") AS "+fieldDisplay.get(i));
                    }
                }
            } else if (valueCalculation == 2) {
                for (int i=0;  i < fieldDisplay.size(); i++){
                    if (!fieldDisplay.get(i).equals("dataTime")){
                        fieldDisplayOne.add("max(a."+fieldDisplay.get(i)+") AS "+fieldDisplay.get(i));
                    }
                }
            } else if (valueCalculation == 3) {
                for (int i=0;  i < fieldDisplay.size(); i++){
                    if (!fieldDisplay.get(i).equals("dataTime")){
                        fieldDisplayOne.add("min(a."+fieldDisplay.get(i)+") AS "+fieldDisplay.get(i));
                    }
                }
            } else if (valueCalculation == 4) {
                for (int i=0;  i < fieldDisplay.size(); i++){
                    if (!fieldDisplay.get(i).equals("dataTime")){
                        fieldDisplayOne.add("sum(a."+fieldDisplay.get(i)+") AS "+fieldDisplay.get(i));
                    }
                }
            }
        } else if (type == 2) {
            fieldDisplayOne.add("a.id");
            fieldDisplayOne.add("a.deviceName");
            fieldDisplayOne.add("FROM_UNIXTIME(UNIX_TIMESTAMP(a.dataTime), '%Y-%m') AS freezingTimes");
            fieldDisplayOne.add("a.dataTime");
            fieldDisplayOne.add("d.monitor_device_name");
            fieldDisplayOne.add("d.id as device_attribute_id");
            if (valueCalculation == 1) {
                for (int i=0;  i < fieldDisplay.size(); i++){
                    if (!fieldDisplay.get(i).equals("dataTime")){
                        fieldDisplayOne.add("AVG(a."+fieldDisplay.get(i)+") AS "+fieldDisplay.get(i));
                    }
                }
            } else if (valueCalculation == 2) {
                for (int i=0;  i < fieldDisplay.size(); i++){
                    if (!fieldDisplay.get(i).equals("dataTime")){
                        fieldDisplayOne.add("max(a."+fieldDisplay.get(i)+") AS "+fieldDisplay.get(i));
                    }
                }
            } else if (valueCalculation == 3) {
                for (int i=0;  i < fieldDisplay.size(); i++){
                    if (!fieldDisplay.get(i).equals("dataTime")){
                        fieldDisplayOne.add("min(a."+fieldDisplay.get(i)+") AS "+fieldDisplay.get(i));
                    }
                }
            } else if (valueCalculation == 4) {

                for (int i=0;  i < fieldDisplay.size(); i++){
                    if (!fieldDisplay.get(i).equals("dataTime")){
                        fieldDisplayOne.add("sum(a."+fieldDisplay.get(i)+") AS "+fieldDisplay.get(i));
                    }
                }
            }
        } else {

            for (int i=0;  i < fieldDisplay.size(); i++){
                if (!fieldDisplay.get(i).equals("dataTime")){
                    fieldDisplayOne.add("a."+fieldDisplay.get(i));
                }
            }
            fieldDisplayOne.add("a.id");
            fieldDisplayOne.add("a.deviceName");
            fieldDisplayOne.add("FROM_UNIXTIME(UNIX_TIMESTAMP(a.dataTime), '%m-%d %H:%i') AS freezingTimes");
            fieldDisplayOne.add("a.dataTime");
            fieldDisplayOne.add("d.monitor_device_name");
            fieldDisplayOne.add("d.id as device_attribute_id");
        }
        return fieldDisplayOne;
    }

    public static Object transformation2(RtSwitchDataVo rtSwitchDataVo, String fieldValue){
        switch (fieldValue) {
            case "id":
                return rtSwitchDataVo.getId();
//               break;
            case "deviceName":
                return rtSwitchDataVo.getDeviceName();
//               break;
            case "commState":
                return rtSwitchDataVo.getCommState();
//               break;
            case "busLive":
                return rtSwitchDataVo.getBusLive();
//               break;
            case "highVoltageAlarm":
                return rtSwitchDataVo.getHighVoltageAlarm();
//               break;
            case "lowVoltageAlarm":
                return rtSwitchDataVo.getLowVoltageAlarm();
//               break;
            case "busLackPhase":
                return rtSwitchDataVo.getBusLackPhase();
//               break;
            case "analog1Alarm":
                return rtSwitchDataVo.getAnalog1Alarm();
//               break;
            case "analog2Alarm":
                return rtSwitchDataVo.getAnalog2Alarm();
//               break;
            case "analog3Alarm":
                return rtSwitchDataVo.getAnalog3Alarm();
//               break;
            case "analog4Alarm":
                return rtSwitchDataVo.getAnalog4Alarm();
//               break;
            case "analog5Alarm":
                return rtSwitchDataVo.getAnalog5Alarm();
//               break;
            case "digitalReserved1":
                return rtSwitchDataVo.getDigitalReserved1();
//               break;
            case "digitalReserved2":
                return rtSwitchDataVo.getDigitalReserved2();
//               break;
            case "digitalReserved3":
                return rtSwitchDataVo.getDigitalReserved3();
//               break;
            case "digitalReserved4":
                return rtSwitchDataVo.getDigitalReserved4();
//               break;
            case "digitalReserved5":
                return rtSwitchDataVo.getDigitalReserved5();
//               break;
            case "digitalReserved6":
                return rtSwitchDataVo.getDigitalReserved6();
//               break;
            case "dataTime":
                return rtSwitchDataVo.getDataTime();
//               break;
            case "LoadLive":
                return rtSwitchDataVo.getLoadLive();
//               break;
            case "Trip":
                return rtSwitchDataVo.getTrip();
//               break;
            case "OverI":
                return rtSwitchDataVo.getOverI();
//               break;
            case "PhaseLoss":
                return rtSwitchDataVo.getPhaseLoss();
//               break;
            case "UnderV":
                return rtSwitchDataVo.getUnderV();
//               break;
            case "OverDemandP":
                return rtSwitchDataVo.getOverDemandP();
//               break;
            case "OverIr":
                return rtSwitchDataVo.getOverIr();
//               break;
            case "OverT1":
                return rtSwitchDataVo.getOverT1();
//               break;
            case "OverT2":
                return rtSwitchDataVo.getOverT2();
//               break;
            case "OverT3":
                return rtSwitchDataVo.getOverT3();
//               break;
            case "DI1":
                return rtSwitchDataVo.getDi1();
//               break;
            case "DI2":
                return rtSwitchDataVo.getDi2();
//               break;
            case "DO1":
                return rtSwitchDataVo.getDo1();
//               break;
            case "DO2":
                return rtSwitchDataVo.getDo2();
//               break;
            case "ResDI1":
                return rtSwitchDataVo.getResDI1();
//               break;
            case "ResDI2":
                return rtSwitchDataVo.getResDI2();
//               break;
            case "ResDI3":
                return rtSwitchDataVo.getResDI3();
//               break;
            case "ArcA":
                return rtSwitchDataVo.getArcA();
//               break;
            case "ArcB":
                return rtSwitchDataVo.getArcB();
//               break;
            case "ArcC":
                return rtSwitchDataVo.getArcC();
//               break;
            case "BusOutage":
                return rtSwitchDataVo.getBusOutage();
//               break;
            case "DevAbnormal":
                return rtSwitchDataVo.getDevAbnormal();
//               break;
            case "EleAlarm":
                return rtSwitchDataVo.getEleAlarm();
//               break;
            case "FireAlarm":
                return rtSwitchDataVo.getFireAlarm();
//               break;
            case "MeasFailure":
                return rtSwitchDataVo.getMeasFailure();
//               break;
            case "Mute":
                return rtSwitchDataVo.getMute();
//               break;
            case "OverDemandS":
                return rtSwitchDataVo.getOverDemandS();
//               break;
            case "OverEvT":
                return rtSwitchDataVo.getOverEvT();
//               break;
            case "OverIH":
                return rtSwitchDataVo.getOverIH();
//               break;
            case "OverT4":
                return rtSwitchDataVo.getOverT4();
//               break;
            case "OverUH":
                return rtSwitchDataVo.getOverUH();
//               break;
            case "OverV":
                return rtSwitchDataVo.getOverV();
//               break;
            case "ResDI4":
                return rtSwitchDataVo.getResDI4();
//               break;
            case "idd":
                return rtSwitchDataVo.getIdd();
//               break;
            case "variableCoding":
                return rtSwitchDataVo.getVariableCoding();
//               break;
            default:
                return null;
        }
    }


}