package com.bizmatics.service.vo;

import com.bizmatics.service.config.CustomerDoubleSerialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.Data;

import java.util.Date;

/**
 *
 * @author fyc
 * @email yuchuan.fu@chinausky.com
 * @date 2025/7/1
 */
@Data
public class SiteLoadAnalysisVO {

    /**
     * 名称（站点名、设备名）
     */
    private String name;

    /**
     * id（站点id、设备id）
     */
    private Integer id;

    /**
     * 编号（设备code）
     */
    private String code;

    /**
     * 额定容量（单位kVA）
     *（站点=装机容量installed_capacity；设备=额定电压（kV）rated_voltage × 额定电流（A）rated_current）
     */
    @JsonSerialize(using = CustomerDoubleSerialize.class)
    // 保留两位小数
    private Double ratedCapacity;

    /**
     * 额定电压 （单位kV）
     */
    @JsonSerialize(using = CustomerDoubleSerialize.class)
    private Double ratedVoltage;

    /**
     * 有功功率（kW）
     */
    private Double p;

    /**
     * 负载率（%）
     */
    @JsonSerialize(using = CustomerDoubleSerialize.class)
    private Double loadRate;

    /**
     * 上报时间
     */
    private Date dataTime;
}
